import { MatPaginator } from '@angular/material/paginator';
import { MatSort, SortDirection } from '@angular/material/sort';
import { ElementRef, EventEmitter } from '@angular/core';
import { SearchFilterDto, SearchFilterTypesDto, SortDto } from "@meshmakers/octo-services";
export declare class OctoListNavigationDataInfo {
    skip: number;
    take: number;
    searchFilter?: SearchFilterDto;
    sort?: SortDto[];
    constructor();
}
export declare class OctoListNavigationOptions {
    language: string | null;
    searchFilterType?: SearchFilterTypesDto;
    searchFilterAttributePaths?: string[];
    constructor();
}
export declare class OctoListNavigation {
    private readonly paginator;
    private readonly sort;
    private readonly searchBox?;
    private readonly octoOptions?;
    loadDataRequest: EventEmitter<OctoListNavigationDataInfo>;
    lastSortDirection: SortDirection | null;
    lastSortField: string | null;
    lastSearchText: string | null;
    constructor(paginator: MatPaginator, sort: MatSort, searchBox?: ElementRef<HTMLInputElement> | undefined, octoOptions?: OctoListNavigationOptions | undefined);
    get loadDataInfo(): OctoListNavigationDataInfo;
    init(): void;
    private loadData;
}
