import { ElementRef, OnInit, AfterViewInit, AfterContentInit, EventEmitter, QueryList, TemplateRef } from '@angular/core';
import { MatPaginator, PageEvent } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { BehaviorSubject, Observable } from 'rxjs';
import { AssetRepoGraphQlDataSource } from '@meshmakers/octo-services';
import { ColumnDefinition, getDisplayName, TableColumn } from './mm-octo-table.model';
import * as i0 from "@angular/core";
export interface ActionColumn {
    columnName: string;
    iconName?: string;
    svgIconName?: string;
}
export interface ToolbarAction {
    iconName?: string;
    svgIconName?: string;
    route?: string;
    actionText: string;
    isDisabled?: Observable<boolean>;
}
export declare class MmOctoTableComponent implements OnInit, AfterViewInit, AfterContentInit {
    dataSource: AssetRepoGraphQlDataSource<any, any, any>;
    cellTemplates: QueryList<TemplateRef<any>>;
    templateMap: Map<string, TemplateRef<any>>;
    actionColumns: ActionColumn[];
    leftToolbarActions: ToolbarAction[];
    optionActions: ActionColumn[];
    searchFilterColumns: string[];
    currentId: string;
    defaultSortColumn: string;
    rowIsClickable: boolean;
    pageSizeOptions: number[];
    selectedPageSize: number;
    rowClicked: EventEmitter<any>;
    searchFilterStringUpdated: EventEmitter<string>;
    selectedRowId: string;
    actionColumnClick: EventEmitter<{
        action: string;
        id: string;
        entry: any;
    }>;
    set columns(cols: ColumnDefinition[]);
    get columns(): TableColumn[];
    _columns: TableColumn[];
    selectedRow: any;
    selectedPageSizeSubject: BehaviorSubject<number>;
    paginator?: MatPaginator;
    sort?: MatSort;
    input?: ElementRef<HTMLInputElement>;
    get columnNames(): string[];
    protected loading: boolean;
    protected isMobile: boolean;
    constructor();
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    loadData(): void;
    protected readonly encodeURIComponent: typeof encodeURIComponent;
    accessElement(element: any, column: TableColumn): any;
    selectedPageSizeChanged($event: PageEvent): void;
    getActionColumnNames(): string[];
    onRowClick(row: any): void;
    isRowSelected(row: any): boolean;
    checkSelectedRow(): void;
    emitRowData(data: {
        action: string;
        id: string;
        entry: any;
    }): void;
    hasOptionActions: (_row: any) => boolean;
    hasActionColumns: () => boolean;
    protected readonly getDisplayName: typeof getDisplayName;
    getTemplate(templateName: string): TemplateRef<any> | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<MmOctoTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MmOctoTableComponent, "mm-octo-table", never, { "dataSource": { "alias": "dataSource"; "required": false; }; "actionColumns": { "alias": "actionColumns"; "required": false; }; "leftToolbarActions": { "alias": "leftToolbarActions"; "required": false; }; "optionActions": { "alias": "optionActions"; "required": false; }; "searchFilterColumns": { "alias": "searchFilterColumns"; "required": false; }; "currentId": { "alias": "currentId"; "required": false; }; "defaultSortColumn": { "alias": "defaultSortColumn"; "required": false; }; "rowIsClickable": { "alias": "rowIsClickable"; "required": false; }; "pageSizeOptions": { "alias": "pageSizeOptions"; "required": false; }; "selectedPageSize": { "alias": "selectedPageSize"; "required": false; }; "selectedRowId": { "alias": "selectedRowId"; "required": false; }; "columns": { "alias": "columns"; "required": false; }; }, { "rowClicked": "rowClicked"; "searchFilterStringUpdated": "searchFilterStringUpdated"; "actionColumnClick": "actionColumnClick"; }, ["cellTemplates"], never, true, never>;
}
